//+------------------------------------------------------------------+
//|                                                   FiboPiv_v1.mq4 |
//|                                                          Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#property indicator_chart_window
extern string  UniqueID        = "FiboPiv1";
extern color   SupportColor    = Red;
extern int     SupportStyle    = STYLE_DOT;
extern color   PivotColor      = Blue;
extern int     PivotStyle      = STYLE_SOLID;
extern color   ResistanceColor = Lime;
extern int     ResistanceStyle = STYLE_DOT;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectDelete(UniqueID+"S1");
   ObjectDelete(UniqueID+"S2");
   ObjectDelete(UniqueID+"S3");
   ObjectDelete(UniqueID+"R1");
   ObjectDelete(UniqueID+"R2");
   ObjectDelete(UniqueID+"R3");
   ObjectDelete(UniqueID+"PIVOT");
   ObjectDelete(UniqueID+"Support 1");
   ObjectDelete(UniqueID+"Support 2");
   ObjectDelete(UniqueID+"Support 3");
   ObjectDelete(UniqueID+"Pivot level");
   ObjectDelete(UniqueID+"Resistance 1");
   ObjectDelete(UniqueID+"Resistance 2");
   ObjectDelete(UniqueID+"Resistance 3");
   Comment(" ");
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   
//----
double rates[1][6],yesterday_close,yesterday_high,yesterday_low;
ArrayCopyRates(rates, Symbol(), PERIOD_D1);

if(DayOfWeek() == 1)
{
   if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,1)) == 5)
   {
       yesterday_close = rates[1][4];
       yesterday_high = rates[1][3];
       yesterday_low = rates[1][2];
   }
   else
   {
      for(int d = 5;d>=0;d--)
      {
         if(TimeDayOfWeek(iTime(Symbol(),PERIOD_D1,d)) == 5)
         {
             yesterday_close = rates[d][4];
             yesterday_high = rates[d][3];
             yesterday_low = rates[d][2];
         }
         
      }  
   }
}
else
{
    yesterday_close = rates[1][4];
    yesterday_high = rates[1][3];
    yesterday_low = rates[1][2];
}


//---- Calculate Pivots

   Comment("\nYesterday quotations:\nH ",yesterday_high,"\nL ",yesterday_low, "\nC ",yesterday_close);
      double R = yesterday_high - yesterday_low;//range
      double p = (yesterday_high + yesterday_low + yesterday_close)/3;// Standard Pivot
      double r3 = p + (R * 1.000);
      double r2 = p + (R * 0.618);
      double r1 = p + (R * 0.382);
      double s1 = p - (R * 0.382);
      double s2 = p - (R * 0.618);
      double s3 = p - (R * 1.000);

      drawLine(r3,"R3", ResistanceColor,ResistanceStyle); drawLabel("Resistance 3",r3,ResistanceColor);
      drawLine(r2,"R2", ResistanceColor,ResistanceStyle); drawLabel("Resistance 2",r2,ResistanceColor);
      drawLine(r1,"R1", ResistanceColor,ResistanceStyle); drawLabel("Resistance 1",r1,ResistanceColor);

      drawLine(p,"PIVOT",PivotColor,PivotStyle); drawLabel("Pivot level",p,PivotColor);

      drawLine(s1,"S1",SupportColor,SupportStyle); drawLabel("Support 1",s1,SupportColor);
      drawLine(s2,"S2",SupportColor,SupportStyle); drawLabel("Support 2",s2,SupportColor);
      drawLine(s3,"S3",SupportColor,SupportStyle); drawLabel("Support 3",s3,SupportColor);
   return(0);
}

//+------------------------------------------------------------------+
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(UniqueID+name) != 0)
    {
        ObjectCreate(UniqueID+name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(UniqueID+name, name, 8, "Arial", EMPTY);
        ObjectSet(UniqueID+name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(UniqueID+name, 0, Time[10], lvl);
    }
}


void drawLine(double lvl,string name, color Col,int type)
{
         if(ObjectFind(UniqueID+name) != 0)
         {
            ObjectCreate(UniqueID+name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            ObjectSet(UniqueID+name, OBJPROP_STYLE, type);
            ObjectSet(UniqueID+name, OBJPROP_COLOR, Col);
            ObjectSet(UniqueID+name,OBJPROP_WIDTH,1);
            
         }
         else
         {
            ObjectDelete(UniqueID+name);
            ObjectCreate(UniqueID+name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            ObjectSet(UniqueID+name, OBJPROP_STYLE, type);
            ObjectSet(UniqueID+name, OBJPROP_COLOR, Col);        
            ObjectSet(UniqueID+name,OBJPROP_WIDTH,1);
          
         }
}